unsigned char SchaltJahr(unsigned int Jahr)
  {
    if ((Jahr % 400)==0)
      {
        return 1;
      }
     else
      {
        if ((Jahr % 100)==0)
          {
            return 0;
          }
         else
          {
            if ((Jahr % 4)==0)
              {
                return 1;
              }
             else
              {
                return 0;
              }
          }
      }
  }

unsigned char WochenTag(unsigned int Jahr, unsigned char Monat, unsigned char Tag)
  {
    // 0=>Montag; 1=>Dienstag; 2=>Mittwoch; 3=>Donnerstag, 4=>Freitag; 5=> Samstag; 6=> Sonntag

    // http://v-d-heyden.de/datum.htm

    // Tage die bis zu dem Monat vergangen sind (0,28,29,59,90,120,151,181,212,243,273,304,334)
    // Die Tabelle gleich mit den Werten MOD 7 fllen (stimmt bei Februar aber nicht???)
    code unsigned char TagMonat[]={0,3,3,6,1,4,6,2,5,0,3,5};

    unsigned char tmp;

    tmp=Jahr % 100;                     // jedes Jahr bleibt ein Tag brig
    tmp=tmp+tmp % 4;                    // fr jedes Schaltjahr bleibt ein Tag brig
    if ((SchaltJahr(Jahr)==1) & (Monat<3)) // wenn das Datum im Schaltjahr und vor dem 29.2. liegt haben wir einen Tag zuviel addiert
      {
        tmp=tmp-1;
      }

    tmp=tmp+TagMonat[Monat-1]+Tag;          // Korrektur fr Monat

    switch ((Jahr/100) % 4)             // Korrektur fr das Jahrhundert
      {
        case 0: tmp=tmp-1;
        case 1: tmp=tmp-2;
        case 2: tmp=tmp-3;
//        case 3:
      }

    return (tmp-1) % 7;                   // 1 abziehen, weil sonst 0=>Sonntag wre
  }


