//*****************************************************************************
// Men

unsigned char MenuePos=0;
unsigned char ArrayPos=0;
unsigned char FirstVisiblePos=0;

void NoAction(void)
  {
    // Platzhalter
  }

void Menue_Show(void)
  {
    unsigned char i;
    unsigned char j;
    unsigned char MenueNo;
    unsigned char tmp;
    unsigned char PosHeight;
    unsigned char XStartPos;
    unsigned char XEndPos;
    unsigned char PosCount;

    // Anzeige lschen
    ClearScreen();

    // 1. Position dieser Menebene suchen
    MenueNo=Menue[ArrayPos].MenueNo;

    if (FirstVisiblePos>MenuePos) FirstVisiblePos=MenuePos;
    if (FirstVisiblePos<(MenuePos-(MaxYPos/8))+1) FirstVisiblePos=(MenuePos-(MaxYPos/8)+1);
    // Menueebene anzeigen
    PosCount=0;
    for (i=ArrayPos+FirstVisiblePos;Menue[i].MenueNo==MenueNo;i++)
      {
        if (PosCount<(MaxYPos/8))
          {
            if (Menue[i].MenueFunction==W1AktivSensor)
              {
                if (ReadEEProm(EEProm+SensorAddress+MenuePos*8)!=0x00)                 
                  {
                    // Sensor-ID ist gespeichert
                    WriteByte(0x1C);
                    WriteByte(0x3E);
                    WriteByte(0x3E);
                    WriteByte(0x3E);
                    WriteByte(0x1C);
                  }    
                else  
                  {
                    // Sensor-ID ist nicht gespeichert
                    WriteByte(0x00);
                    WriteByte(0x00);
                    WriteByte(0x00);
                    WriteByte(0x00);
                    WriteByte(0x00);
                  }
              }  
            
            if (i==(ArrayPos+MenuePos)) 
              {
                invers=1;
                WriteByte(0x7E);                              // rund links
                WriteByte(0xFF);
                puts(Menue[i].MenueText);
                WriteByte(0x7E);                              // rund rechts
                invers=0;
              }  
             else
              {
                puts(" ");
                puts(Menue[i].MenueText);
              }
            puts(CRLF);
          }   
        PosCount=PosCount+1;
      }
      
    // Scrollbalken zeichnen  
    PosHeight=MaxYPos/(i-ArrayPos);
    XStartPos=PosHeight*MenuePos;
    XEndPos=XStartPos+PosHeight;
    
    for (i=0;i<(MaxYPos/8);i++)
      {
        SetCursor(MaxXPos-2,i);
        tmp=0x00;
        for (j=0;j<8;j++)
          {
            tmp=tmp>>1;
            if ((((i*8)+j)<XStartPos)||(((i*8)+j)>XEndPos))
              {
                tmp=tmp|0x80;
              }  
          }
        WriteByte(tmp);
        WriteByte(~tmp);
      }      
  }

void Menue_Set(void)
  {
    unsigned char i;
    unsigned char MenueNo;

    if (Menue[ArrayPos+MenuePos].NextMenueNo)
      {
        // Nchst tiefere Menueebene anzeigen
        MenueNo=Menue[ArrayPos+MenuePos].NextMenueNo;
        MenuePos=0;

        for (i=0;Menue[i].MenueNo!=MenueNo;i++);
        ArrayPos=i;
        FirstVisiblePos=0;
        Menue_Show();
      }
     else
      {
        // Funktion des Menuepunktes ausfhren
        Menue[ArrayPos+MenuePos].MenueFunction(MenuePos);
      }
  }

void Menue_Back(void)
  {
    unsigned char i;
    unsigned char MenueNo;

    MenueNo=Menue[ArrayPos].MenueNo;

    if (MenueNo>0)
      {
        for (i=0;Menue[i].NextMenueNo!=MenueNo;i++);

        if (Menue[i].NextMenueNo==MenueNo)
          {
            MenuePos=i;
            MenueNo=Menue[i].MenueNo;
            for (i=i;MenueNo==Menue[i].MenueNo;i--);
            i=i+1;
            MenuePos=MenuePos-i;                 // auf die MenuePosition zurckkehren, von der man in das Menue gelangte
            ArrayPos=i;
            Menue_Show();
          }
      }
     else
      {
        // Menue ausblenden
      }
  }

void Menue_Up(void)
  {
    if (Menue[ArrayPos].MenueNo==Menue[ArrayPos+MenuePos+1].MenueNo)
      {
        MenuePos=MenuePos+1;
        Menue_Show();
      }
  }

void Menue_Down(void)
  {
   if (Menue[ArrayPos].MenueNo==Menue[ArrayPos+MenuePos-1].MenueNo)
      {
        MenuePos=MenuePos-1;
        Menue_Show();
      }
  }

// Ende Men
//*****************************************************************************
