typedef struct MENU {
  const unsigned char *MenueText;
  unsigned char MenueNo;
  unsigned char NextMenueNo;
  void (*MenueFunction)( void );
} MENUE_ENTRY;

// Men-Definition
__code const MENUE_ENTRY Menue[]=              // Mentext, MenNr, UnterMenNr, Zeiger auf aufzurufende Funktion
  {
    { "Test1",    0, 0, test1 },
    { "Test2",    0, 2, NoAction },
    { "Test3",    0, 3, NoAction },
    { "Test4",    0, 1, NoAction },
    { "Test5",    0, 1, NoAction },
    { "Test6",    0, 1, NoAction },
    { "Test7",    0, 1, NoAction },
    { "Test8",    0, 1, NoAction },
    { "Displaykontrast", 2, 0, test2 },
    { "Wire 1 Devices",  2, 0, W1SearchAll },
    { "Wohnzimmer",      3, 0, W1AktivSensor},
    { "Schlafzimmer",    3, 0, W1AktivSensor},
    { "Kueche",          3, 0, W1AktivSensor},
    { "Bad",             3, 0, W1AktivSensor},
    { "Flur",            3, 0, W1AktivSensor},
    { "Aussen",          3, 0, W1AktivSensor},
    { "Vorlauf",         3, 0, W1AktivSensor},
    { "Ruecklauf",       3, 0, W1AktivSensor}
  };

#include "Men.c"

// Functions-Prototypen
void NoAction(void);
void Menue_Show(void);
void Menue_Set(void);
void Menue_Back(void);
void Menue_Up(void);
void Menue_Down(void);

